/**********************************************************************************
 * Copyright (c) 2021 Process Systems Engineering (AVT.SVT), RWTH Aachen University
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 **********************************************************************************/
#include "coopBendersSubproblem.hpp"

unsigned long PlantbusSubproblem::InitObject(){
	for (int i = 0; i < equations_.size(); ++i) {
		std::string name = equations_[i].get(GRB_StringAttr_ConstrName);
		if (name.find(coupling_equation_name_) != std::string::npos) {
			coupling_equation_.push_back(i);
		}
		else {
			constraints_.push_back(i);
		}
	}
	for (int i = 0; i < variables_.size(); ++i) {
		std::string name = variables_[i].get(GRB_StringAttr_VarName);
		if (name.find("p_coup") != std::string::npos) {
			p_slack_.push_back(i);
		}
		else if (name.find("n_coup") != std::string::npos) {
			n_slack_.push_back(i);
		}
		else {
			model_vars_.push_back(i);
		}
	}
	return constraints_.size() + model_vars_.size();
}

//Constructor initializes SP model
PlantbusSubproblem::PlantbusSubproblem(const GRBEnv& env, const std::string& option_path, const double plant_load, const unsigned num_timesteps) :
	options_{option_path}, model_{env, options_.workspace_dir + options_.lp_file},
	equations_{model_.getConstrs(), static_cast<size_t>(model_.get(GRB_IntAttr_NumConstrs))},
	variables_{model_.getVars(), static_cast<size_t>(model_.get(GRB_IntAttr_NumVars))},
	coupling_equation_name_{"masterSubCoupling"}, coupling_equation_{}, constraints_{}, model_vars_{}, n_slack_{},
	p_slack_{}, num_timesteps_{num_timesteps}, pow_sugg_(num_timesteps_, 0.0), plant_load_{plant_load},
	rhs_num_records_{InitObject()} {
		model_.set(GRB_IntParam_Method, 1);
}


void PlantbusSubproblem::Solve() {
	int i = 0;
	for (const int index : coupling_equation_) {
		equations_[index].set(GRB_DoubleAttr_RHS, -pow_sugg_[i]);
		++i;
	}

	try {
		model_.optimize();
	}
	catch (const GRBException& e) {
		std::cout << "GRBException: " << e.getMessage() << std::endl;
		throw;
	}
}

int PlantbusSubproblem::GetModelStatus() const {
	return model_.get(GRB_IntAttr_Status);
}

//Generalized version to compute rhs of the cut generated by this subproblem
double PlantbusSubproblem::GetNewRhs() const {
	//Should now have some positive number of records for computing rhs of the cut.
	//If that is not the case, throw an exception.
	if (rhs_num_records_ == 0) {
		throw std::runtime_error("Error: no records found to compute rhs of benders cut.");
	}

	std::vector<double> b(rhs_num_records_, 0.0);
	std::vector<double> lambda(rhs_num_records_, 0.0);
	int i = 0;

	for (const int index : model_vars_) {
		const GRBVar& var = variables_[index];
		if (var.get(GRB_DoubleAttr_X) == var.get(GRB_DoubleAttr_LB)) {
			b[i] = var.get(GRB_DoubleAttr_X);
			lambda[i] = var.get(GRB_DoubleAttr_RC);
			++i;
		}
		else if (var.get(GRB_DoubleAttr_X) == var.get(GRB_DoubleAttr_UB)) {
			b[i] = var.get(GRB_DoubleAttr_X);
			lambda[i] = var.get(GRB_DoubleAttr_RC);
			++i;
		}
	}

	for (const int index : constraints_) {
		const GRBConstr& constraint = equations_[index];
		b[i] = constraint.get(GRB_DoubleAttr_RHS);
		lambda[i] = constraint.get(GRB_DoubleAttr_Pi);
		++i;
	}

	return std::inner_product(b.begin(), b.end(), lambda.begin(), 0.0);
}

//Computes the value of the lhs of the subproblem cut given the last power profile
double PlantbusSubproblem::GetCurrLhs() const {
	std::vector<double> lambda(num_timesteps_);
	int i = 0;
	for (const int index : coupling_equation_) {
		lambda[i] = equations_[index].get(GRB_DoubleAttr_Pi);
		++i;
	}

	return std::inner_product(pow_sugg_.begin(), pow_sugg_.end(), lambda.begin(), 0.0);
}

//Computes the coefficient of the new cut generated by the subproblem for a given time
double PlantbusSubproblem::GetNewCoeff(const unsigned key) const {
	const GRBConstr& eq = equations_[coupling_equation_.at(key)];
	return eq.get(GRB_DoubleAttr_Pi) / plant_load_;
}

std::vector<double> PlantbusSubproblem::GetNewCoeffs() const {
	std::vector<double> result(num_timesteps_);
	for (unsigned i = 0; i < num_timesteps_; ++i) {
		const GRBConstr& eq = equations_[coupling_equation_.at(i)];
		result[i] = eq.get(GRB_DoubleAttr_Pi) / plant_load_;
	}
	return result;
}

double PlantbusSubproblem::GetSubproblemObjective() const {
	return model_.get(GRB_DoubleAttr_ObjVal);
}

double PlantbusSubproblem::GenerateAndVerifyCut() const {
	const double curr_lhs = GetCurrLhs();
	const double rhs = GetNewRhs();

	//Verify the generated cut.
	//Done by subtracting inserting the last power suggestion into lhs of the cut (this is curr_lhs)
	//and subtracting that from rhs to get the cut in the form rhs-lhs <= 0.
	//This value (rhs-lhs) should be the same as the optimal value of the dual subproblem.
	//By strong duality (holds since we are solving an LP to optimality), the optimal value of the dual is the same as the optimal value of the primal.
	//So even though we don't solve the dual, we can get its optimal value by taking the optimal value of the primal.
	//For a correct cut, both values (rhs-lhs of the new cut and optimum of dual) should be equal.
	//(See https://arthur.matheo.net/a-short-introduction-to-benders/)
	const double objective = GetSubproblemObjective();
	const double verify = rhs - curr_lhs;
	if (abs(objective - verify) > 1e-7) {
		const std::string msg = "error in cut generation. Verification difference is " + std::to_string(objective - verify);
		throw BadCutException(msg);
	}
	//check if the current solution will be cut off, if not: check whether the subproblem is feasible
	if (curr_lhs > rhs || abs(verify) < 1e-14) { //floating point comparison for equality
		throw IrrelevantCutException("");
	}

	return rhs;
}

double PlantbusSubproblem::get_plant_load() const {
	return plant_load_;
}

double PlantbusSubproblem::get_feas_distance() const {
	return this->GetSubproblemObjective()*plant_load_;
}
std::vector<double> PlantbusSubproblem::get_feas_sol() const {
	std::vector<double> result(num_timesteps_);
	for (unsigned i = 0; i < num_timesteps_; ++i) {
		result[i] = plant_load_ * (pow_sugg_[i] + variables_[p_slack_.at(i)].get(GRB_DoubleAttr_X) - variables_[n_slack_.at(i)].get(GRB_DoubleAttr_X));
	}
	return result;
}
double PlantbusSubproblem::get_feas_sol(const unsigned key) const {
	return plant_load_ * (pow_sugg_[key] + variables_[p_slack_.at(key)].get(GRB_DoubleAttr_X) - variables_[n_slack_.at(key)].get(GRB_DoubleAttr_X));
}

std::vector<double> PlantbusSubproblem::GetNSlackValues() const {
	std::vector<double> result(num_timesteps_);
	for (unsigned i = 0; i < num_timesteps_; ++i) {
		result[i] = variables_[n_slack_.at(i)].get(GRB_DoubleAttr_X);
	}
	return result;
}

std::vector<double> PlantbusSubproblem::GetPSlackValues() const {
	std::vector<double> result(num_timesteps_);
	for (unsigned i = 0; i < num_timesteps_; ++i) {
		result[i] = variables_[p_slack_.at(i)].get(GRB_DoubleAttr_X);
	}
	return result;
}

std::vector<double> PlantbusSubproblem::get_pow_sugg() const {
	return pow_sugg_;
}

double PlantbusSubproblem::get_pow_sugg(const unsigned i) const {
	return pow_sugg_[i];
}

void PlantbusSubproblem::set_pow_sugg(const unsigned key, const double val) {
	pow_sugg_[key] = val;
}
void PlantbusSubproblem::set_pow_sugg(const std::vector<double>& in) {
	pow_sugg_ = in;
}

GRBModel& PlantbusSubproblem::GetModel() {
	return model_;
}

